import { Dispatch, SetStateAction } from "react";
export declare type StateActions<TState> = {
    readonly get: TState | undefined;
    readonly set: Dispatch<SetStateAction<TState>>;
};
declare type HookAction<TState> = (props: unknown) => [TState | undefined, Dispatch<SetStateAction<TState>>];
declare const renderer: <TState>(action: HookAction<TState>, path?: string | undefined) => {
    result: import("@testing-library/react-hooks").RenderResult<[TState | undefined, Dispatch<SetStateAction<TState>>]>;
    history: import("history").MemoryHistory<unknown>;
    state: {
        readonly get: TState | undefined;
        readonly set: Dispatch<SetStateAction<TState>>;
    };
};
export declare const multiRenderer: <TState>(action: HookAction<TState>[], path?: string | undefined) => {
    history: import("history").MemoryHistory<unknown>;
    states: {
        readonly get: TState | undefined;
        readonly set: Dispatch<SetStateAction<TState>>;
    }[];
};
export default renderer;
